## EDBusUserPrompter EDBusUserPrompter |

## Functions

gboolean | e_dbus_user_prompter_call_extension_prompt_sync ()
void | e_dbus_user_prompter_call_extension_prompt ()
gboolean | e_dbus_user_prompter_call_extension_prompt_finish ()
void | e_dbus_user_prompter_complete_extension_prompt ()
gboolean | e_dbus_user_prompter_call_prompt_sync ()
void | e_dbus_user_prompter_call_prompt ()
gboolean | e_dbus_user_prompter_call_prompt_finish ()
void | e_dbus_user_prompter_complete_prompt ()
void | e_dbus_user_prompter_emit_extension_response ()
void | e_dbus_user_prompter_emit_response ()
GDBusInterfaceInfo * | e_dbus_user_prompter_interface_info ()
guint | e_dbus_user_prompter_override_properties ()
EDBusUserPrompter * | e_dbus_user_prompter_proxy_new_sync ()
void | e_dbus_user_prompter_proxy_new ()
EDBusUserPrompter * | e_dbus_user_prompter_proxy_new_finish ()
EDBusUserPrompter * | e_dbus_user_prompter_proxy_new_for_bus_sync ()
void | e_dbus_user_prompter_proxy_new_for_bus ()
EDBusUserPrompter * | e_dbus_user_prompter_proxy_new_for_bus_finish ()
EDBusUserPrompter * | e_dbus_user_prompter_skeleton_new ()

## Signals

void | extension-response | Run Last
gboolean | handle-extension-prompt | Run Last
gboolean | handle-prompt | Run Last
void | response | Run Last

## Types and Values

| EDBusUserPrompter
struct | EDBusUserPrompterProxy
struct | EDBusUserPrompterSkeleton

## Object Hierarchy

        GInterface
        ╰── EDBusUserPrompter
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── EDBusUserPrompterSkeleton
        ╰── GDBusProxy
            ╰── EDBusUserPrompterProxy

## Prerequisites

EDBusUserPrompter requires GObject.

## Implemented Interfaces

EDBusUserPrompterProxy implements GDBusInterface, GInitable, GAsyncInitable and EDBusUserPrompter.

EDBusUserPrompterSkeleton implements GDBusInterface and EDBusUserPrompter.

## Known Implementations

EDBusUserPrompter is implemented by EDBusUserPrompterProxy and EDBusUserPrompterSkeleton.

## Description

## Functions

### e_dbus_user_prompter_call_extension_prompt_sync ()

    gboolean
    e_dbus_user_prompter_call_extension_prompt_sync
                                   (EDBusUserPrompter *proxy,
                                    const gchar *arg_dialog_name,
                                    const gchar *const *arg_parameters,
                                    gint *out_id,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `ExtensionPrompt()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_user_prompter_call_extension_prompt()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusUserPrompterProxy. |
arg_dialog_name | Argument to pass with the method invocation. |
arg_parameters | Argument to pass with the method invocation. |
out_id | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### e_dbus_user_prompter_call_extension_prompt ()

    void
    e_dbus_user_prompter_call_extension_prompt
                                   (EDBusUserPrompter *proxy,
                                    const gchar *arg_dialog_name,
                                    const gchar *const *arg_parameters,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `ExtensionPrompt()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_user_prompter_call_extension_prompt_finish()` to get the result of the operation.

See `e_dbus_user_prompter_call_extension_prompt_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusUserPrompterProxy. |
arg_dialog_name | Argument to pass with the method invocation. |
arg_parameters | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### e_dbus_user_prompter_call_extension_prompt_finish ()

    gboolean
    e_dbus_user_prompter_call_extension_prompt_finish
                                   (EDBusUserPrompter *proxy,
                                    gint *out_id,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_user_prompter_call_extension_prompt()`.

#### Parameters

proxy | A EDBusUserPrompterProxy. |
out_id | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_user_prompter_call_extension_prompt()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### e_dbus_user_prompter_complete_extension_prompt ()

    void
    e_dbus_user_prompter_complete_extension_prompt
                                   (EDBusUserPrompter *object,
                                    GDBusMethodInvocation *invocation,
                                    gint id);

Helper function used in service implementations to finish handling invocations of the `ExtensionPrompt()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusUserPrompter. |
invocation | A GDBusMethodInvocation. | [transfer full]
id | Parameter to return. |

### e_dbus_user_prompter_call_prompt_sync ()

    gboolean
    e_dbus_user_prompter_call_prompt_sync (EDBusUserPrompter *proxy,
                                           const gchar *arg_type,
                                           const gchar *arg_title,
                                           const gchar *arg_primary_text,
                                           const gchar *arg_secondary_text,
                                           gboolean arg_use_markup,
                                           const gchar *const *arg_button_captions,
                                           gint *out_id,
                                           GCancellable *cancellable,
                                           GError **error);

Synchronously invokes the `Prompt()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `e_dbus_user_prompter_call_prompt()` for the asynchronous version of this method.

#### Parameters

proxy | A EDBusUserPrompterProxy. |
arg_type | Argument to pass with the method invocation. |
arg_title | Argument to pass with the method invocation. |
arg_primary_text | Argument to pass with the method invocation. |
arg_secondary_text | Argument to pass with the method invocation. |
arg_use_markup | Argument to pass with the method invocation. |
arg_button_captions | Argument to pass with the method invocation. |
out_id | Return location for return parameter or `NULL` to ignore. | [out]
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### e_dbus_user_prompter_call_prompt ()

    void
    e_dbus_user_prompter_call_prompt (EDBusUserPrompter *proxy,
                                      const gchar *arg_type,
                                      const gchar *arg_title,
                                      const gchar *arg_primary_text,
                                      const gchar *arg_secondary_text,
                                      gboolean arg_use_markup,
                                      const gchar *const *arg_button_captions,
                                      GCancellable *cancellable,
                                      GAsyncReadyCallback callback,
                                      gpointer user_data);

Asynchronously invokes the `Prompt()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_user_prompter_call_prompt_finish()` to get the result of the operation.

See `e_dbus_user_prompter_call_prompt_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A EDBusUserPrompterProxy. |
arg_type | Argument to pass with the method invocation. |
arg_title | Argument to pass with the method invocation. |
arg_primary_text | Argument to pass with the method invocation. |
arg_secondary_text | Argument to pass with the method invocation. |
arg_use_markup | Argument to pass with the method invocation. |
arg_button_captions | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### e_dbus_user_prompter_call_prompt_finish ()

    gboolean
    e_dbus_user_prompter_call_prompt_finish
                                   (EDBusUserPrompter *proxy,
                                    gint *out_id,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_user_prompter_call_prompt()`.

#### Parameters

proxy | A EDBusUserPrompterProxy. |
out_id | Return location for return parameter or `NULL` to ignore. | [out]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_user_prompter_call_prompt()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

### e_dbus_user_prompter_complete_prompt ()

    void
    e_dbus_user_prompter_complete_prompt (EDBusUserPrompter *object,
                                          GDBusMethodInvocation *invocation,
                                          gint id);

Helper function used in service implementations to finish handling invocations of the `Prompt()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A EDBusUserPrompter. |
invocation | A GDBusMethodInvocation. | [transfer full]
id | Parameter to return. |

### e_dbus_user_prompter_emit_extension_response ()

    void
    e_dbus_user_prompter_emit_extension_response
                                   (EDBusUserPrompter *object,
                                    gint arg_id,
                                    gint arg_response,
                                    const gchar *const *arg_values);

Emits the "ExtensionResponse" D-Bus signal.

#### Parameters

object | A EDBusUserPrompter. |
arg_id | Argument to pass with the signal. |
arg_response | Argument to pass with the signal. |
arg_values | Argument to pass with the signal. |

### e_dbus_user_prompter_emit_response ()

    void
    e_dbus_user_prompter_emit_response (EDBusUserPrompter *object,
                                        gint arg_id,
                                        gint arg_response_button);

Emits the "Response" D-Bus signal.

#### Parameters

object | A EDBusUserPrompter. |
arg_id | Argument to pass with the signal. |
arg_response_button | Argument to pass with the signal. |

### e_dbus_user_prompter_interface_info ()

    GDBusInterfaceInfo *
    e_dbus_user_prompter_interface_info (void);

Gets a machine-readable description of the org.gnome.evolution.dataserver.UserPrompter D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

### e_dbus_user_prompter_override_properties ()

    guint
    e_dbus_user_prompter_override_properties
                                   (GObjectClass *klass,
                                    guint property_id_begin);

Overrides all GObject properties in the EDBusUserPrompter interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject-derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

### e_dbus_user_prompter_proxy_new_sync ()

    EDBusUserPrompter *
    e_dbus_user_prompter_proxy_new_sync (GDBusConnection *connection,
                                         GDBusProxyFlags flags,
                                         const gchar *name,
                                         const gchar *object_path,
                                         GCancellable *cancellable,
                                         GError **error);

Synchronously creates a proxy for the D-Bus interface org.gnome.evolution.dataserver.UserPrompter. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `e_dbus_user_prompter_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusUserPrompterProxy]

### e_dbus_user_prompter_proxy_new ()

    void
    e_dbus_user_prompter_proxy_new (GDBusConnection *connection,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.gnome.evolution.dataserver.UserPrompter. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_user_prompter_proxy_new_finish()` to get the result of the operation.

See `e_dbus_user_prompter_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [allow-none]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### e_dbus_user_prompter_proxy_new_finish ()

    EDBusUserPrompter *
    e_dbus_user_prompter_proxy_new_finish (GAsyncResult *res,
                                           GError **error);

Finishes an operation started with `e_dbus_user_prompter_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_user_prompter_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusUserPrompterProxy]

### e_dbus_user_prompter_proxy_new_for_bus_sync ()

    EDBusUserPrompter *
    e_dbus_user_prompter_proxy_new_for_bus_sync
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Like `e_dbus_user_prompter_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `e_dbus_user_prompter_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusUserPrompterProxy]

### e_dbus_user_prompter_proxy_new_for_bus ()

    void
    e_dbus_user_prompter_proxy_new_for_bus
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Like `e_dbus_user_prompter_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `e_dbus_user_prompter_proxy_new_for_bus_finish()` to get the result of the operation.

See `e_dbus_user_prompter_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [allow-none]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

### e_dbus_user_prompter_proxy_new_for_bus_finish ()

    EDBusUserPrompter *
    e_dbus_user_prompter_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `e_dbus_user_prompter_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `e_dbus_user_prompter_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type EDBusUserPrompterProxy]

### e_dbus_user_prompter_skeleton_new ()

    EDBusUserPrompter *
    e_dbus_user_prompter_skeleton_new (void);

Creates a skeleton object for the D-Bus interface org.gnome.evolution.dataserver.UserPrompter.

#### Returns

The skeleton object.

[transfer full][type EDBusUserPrompterSkeleton]

## Types and Values

### EDBusUserPrompter

    typedef struct _EDBusUserPrompter EDBusUserPrompter;

Abstract interface type for the D-Bus interface org.gnome.evolution.dataserver.UserPrompter.

### struct EDBusUserPrompterProxy

    struct EDBusUserPrompterProxy;

The EDBusUserPrompterProxy structure contains only private data and should only be accessed using the provided API.

### struct EDBusUserPrompterSkeleton

    struct EDBusUserPrompterSkeleton;

The EDBusUserPrompterSkeleton structure contains only private data and should only be accessed using the provided API.

## Signal Details

### The `“extension-response”` signal

    void
    user_function (EDBusUserPrompter *object,
                   gint               arg_id,
                   gint               arg_response,
                   GStrv              arg_values,
                   gpointer           user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "ExtensionResponse" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A EDBusUserPrompter. |
arg_id | Argument. |
arg_response | Argument. |
arg_values | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“handle-extension-prompt”` signal

    gboolean
    user_function (EDBusUserPrompter     *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_dialog_name,
                   GStrv                  arg_parameters,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `ExtensionPrompt()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_user_prompter_complete_extension_prompt()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusUserPrompter. |
invocation | A GDBusMethodInvocation. |
arg_dialog_name | Argument passed by remote caller. |
arg_parameters | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-prompt”` signal

    gboolean
    user_function (EDBusUserPrompter     *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_type,
                   gchar                 *arg_title,
                   gchar                 *arg_primary_text,
                   gchar                 *arg_secondary_text,
                   gboolean               arg_use_markup,
                   GStrv                  arg_button_captions,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Prompt()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `e_dbus_user_prompter_complete_prompt()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A EDBusUserPrompter. |
invocation | A GDBusMethodInvocation. |
arg_type | Argument passed by remote caller. |
arg_title | Argument passed by remote caller. |
arg_primary_text | Argument passed by remote caller. |
arg_secondary_text | Argument passed by remote caller. |
arg_use_markup | Argument passed by remote caller. |
arg_button_captions | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“response”` signal

    void
    user_function (EDBusUserPrompter *object,
                   gint               arg_id,
                   gint               arg_response_button,
                   gpointer           user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "Response" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A EDBusUserPrompter. |
arg_id | Argument. |
arg_response_button | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last